using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace Seminar
{
    public partial class ControlBitString : UserControl,xmlInterface
    {
        public ControlBitString()
        {
            InitializeComponent();
        }

        public int SizeBits
        {
            get
            {
                int a;
                if (Int32.TryParse(textBoxSize.Text, out a))
                    return a;
                else return 0;
            }
        }
        public bool UseOnePointCrossover
        {
            get
            {
                return checkBoxOnePointCrx.Checked;
            }
        }
        public bool UseUniformCrossover
        {
            get
            {
                return checkBoxUniformCrossover.Checked;
            }
        }

        public bool UseSimpleMutation
        {
            get
            {
                return checkBoxSimpleMutation.Checked;
            }
        }

        public bool UseMixingMutation
        {
            get
            {
                return checkBoxMixingMutation.Checked;
            }
        }

        public bool ToXml(XmlDocument xmlDoc, XmlElement parent)
        {
            XmlElement bitSize = xmlDoc.CreateElement("Entry");
            XmlAttribute at = xmlDoc.CreateAttribute("key");
            at.Value = "size";
            bitSize.SetAttributeNode(at);
            bitSize.InnerText = SizeBits.ToString();
            if (SizeBits == 0) return false;
            parent.AppendChild(bitSize);
            

            if (checkBoxMixingMutation.Checked)
            {
                XmlElement mixMut = xmlDoc.CreateElement("Entry");
                at = xmlDoc.CreateAttribute("key");
                at.Value = "mut.mix";
                mixMut.SetAttributeNode(at);
                mixMut.InnerText = "1";
                parent.AppendChild(mixMut);
            }

            if (checkBoxSimpleMutation.Checked)
            {
                XmlElement simpleMut = xmlDoc.CreateElement("Entry");
                at = xmlDoc.CreateAttribute("key");
                at.Value = "mut.simple";
                simpleMut.SetAttributeNode(at);
                simpleMut.InnerText = "1";
                parent.AppendChild(simpleMut);
            }

            if (checkBoxOnePointCrx.Checked)
            {
                XmlElement onePointCrx = xmlDoc.CreateElement("Entry");
                at = xmlDoc.CreateAttribute("key");
                at.Value = "crx.onepoint";
                onePointCrx.SetAttributeNode(at);
                onePointCrx.InnerText = "1";
                parent.AppendChild(onePointCrx);
            }

            if (checkBoxOnePointCrx.Checked)
            {
                XmlElement uniformCrx = xmlDoc.CreateElement("Entry");
                at = xmlDoc.CreateAttribute("key");
                at.Value = "crx.uniform";
                uniformCrx.SetAttributeNode(at);
                uniformCrx.InnerText = "1";
                parent.AppendChild(uniformCrx);
            }
            return true;


        }


        public bool FromXml(XmlElement elem)
        {
            if (elem.Name != "BitString") return false;
            //XmlNodeList entryList   
            foreach (XmlNode node in elem.ChildNodes)
            {
                if (!(node is XmlElement)) continue;
                switch (((XmlElement)node).GetAttribute("key"))
                {
                    case "size":
                        textBoxSize.Text = node.InnerText;
                        break;
                    case "mut.simple":
                        if (node.InnerText == "1")
                            checkBoxSimpleMutation.Checked = true;
                        break;
                    case "mut.mix":
                        if (node.InnerText == "1")
                            checkBoxMixingMutation.Checked = true;
                        break;
                    case "crx.onepoint":
                        if (node.InnerText == "1")
                            checkBoxOnePointCrx.Checked = true;
                        break;
                    case "crx.uniform":
                        if (node.InnerText == "1")
                            checkBoxUniformCrossover.Checked = true;
                        break;
                }
            }
            return true;
        }


    }
}
