using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace Seminar
{
    public partial class ControlSteadyState : UserControl,xmlInterface
    {
        public ControlSteadyState()
        {
            InitializeComponent();
        }

        public int TournamentSize
        {
            get
            {
                return (int)numericUpDown1.Value;
            }
        }
        public bool ToXml(XmlDocument xmlDoc, XmlElement parent)
        {
            XmlElement tsize = xmlDoc.CreateElement("Entry");
            XmlAttribute at = xmlDoc.CreateAttribute("key");
            at.Value = "tsize";
            tsize.SetAttributeNode(at);
            tsize.InnerText = TournamentSize.ToString();
            if (TournamentSize <= 0) return false;
            parent.AppendChild(tsize);
            
            return true;
        }

        public bool FromXml(XmlElement elem)
        {
            if (elem.Name != "SteadyStateTournament") return false;
            //XmlNodeList entryList   
            foreach (XmlNode node in elem.ChildNodes)
            {
                if (!(node is XmlElement)) continue;
                switch (((XmlElement)node).GetAttribute("key"))
                {
                    case "tsize":
                        numericUpDown1.Value = Int32.Parse(node.InnerText);
                        break;
                }
            }
            return true;
        }


    }
}
