using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Globalization;

namespace Seminar
{
    public partial class ControlRoulleteWheel : UserControl, xmlInterface
    {
        int selectionPresure;
        double crossoverProbability;
        NumberFormatInfo numberInfo;
        public ControlRoulleteWheel()
        {
            InitializeComponent();
            numberInfo = new NumberFormatInfo();
            numberInfo.CurrencyDecimalSeparator = ".";
        }

        public int SelectionPressure
        {
            get
            {
                if (Int32.TryParse(textBoxSelPressure.Text,out selectionPresure))
                    return selectionPresure;
                else return -1;
            }
        }
        public double CrossoverProbability
        {
            get
            {
                if (Double.TryParse(textBoxCrxProbability.Text,NumberStyles.AllowDecimalPoint,numberInfo, out crossoverProbability))
                    return crossoverProbability;
                else return -1;
            }
        }

        public bool ToXml(XmlDocument xmlDoc, XmlElement parent)
        {
            XmlElement crossoverProb = xmlDoc.CreateElement("Entry");
            XmlAttribute at = xmlDoc.CreateAttribute("key");
            at.Value = "crxprob";
            crossoverProb.SetAttributeNode(at);
            crossoverProb.InnerText = CrossoverProbability.ToString(numberInfo);
            if (CrossoverProbability < 0 || selectionPresure < 0) return false;
            parent.AppendChild(crossoverProb);

            XmlElement selectionPressure = xmlDoc.CreateElement("Entry");
            at = xmlDoc.CreateAttribute("key");
            at.Value = "selpressure";
            selectionPressure.SetAttributeNode(at);
            selectionPressure.InnerText = SelectionPressure.ToString();
            parent.AppendChild(selectionPressure);

          //  parent.AppendChild(crossoverProb);
           // parent.AppendChild(selectionPressure);

            return true;
        }


        public bool FromXml(XmlElement elem)
        {
            if (elem.Name != "RouletteWheel") return false;
            //XmlNodeList entryList   
            foreach (XmlNode node in elem.ChildNodes)
            {
                if(!(node is XmlElement))continue;
                switch (((XmlElement)node).GetAttribute("key"))
                {
                    case "crxprob":
                        textBoxCrxProbability.Text = node.InnerText;
                        break;
                    case "selpressure":
                        textBoxSelPressure.Text = node.InnerText;
                        break;
                }
            }
            return true;
        }
                
            
            
    }
}

